//Copyright (C) 2004, Brian Enigma <enigma at netninja.com>
//This file is part of MagicCodes.
//
//MagicCodes is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//MagicCodes is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Foobar; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package org.ninjasoft.magiccodes.plugins;

/**
 * The plugin interface
 * @author enigma
 */
public interface Plugin {
    /** Return a simple one or two word name describing this plugin */
    public String getName();
    /** Return a complete description of this plugin */
    public String getDescription();
    /** Returns whether this plugin uses the key at all */
    public boolean usesKey();
    /** Does this plugin actually transform stuff, or is it simply informational.  Informational
        plugins ALWAYS have text mode output. */
    public boolean isInformational();
    /** Take input data and spit out output data */
    public int[] doAction(int[] in, int[] key);
}
