package org.ninjasoft.magiccodes.logic;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.ninjasoft.magiccodes.logic.Translator;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class TranslatorTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  org.ninjasoft.magiccodes.logic.Translator translator = null;
  // JUnitDoclet end class
  
  public TranslatorTest(String name) {
    // JUnitDoclet begin method TranslatorTest
    super(name);
    // JUnitDoclet end method TranslatorTest
  }
  
  public org.ninjasoft.magiccodes.logic.Translator createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance
    return new org.ninjasoft.magiccodes.logic.Translator();
    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    translator = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    translator = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testByteToBin() throws Exception {
    // JUnitDoclet begin method byteToBin
    assertEquals(Translator.byteToBin(new int[] {0x01, 0x80, 0xff}),
        "000000011000000011111111");
    assertEquals(Translator.byteToBin(new int[] {'A', 'B', 'C'}),
        "010000010100001001000011");
    // JUnitDoclet end method byteToBin
  }
  
  public void testBinToByte() throws Exception {
    // JUnitDoclet begin method binToByte
    int[] data = Translator.binToByte("000000011000000011111111");
    assertEquals(data[0], 0x01);
    assertEquals(data[1], 0x80);
    assertEquals(data[2], 0xff);
    data = Translator.binToByte("010000010100001001000011");
    assertEquals(data[0], 'A');
    assertEquals(data[1], 'B');
    assertEquals(data[2], 'C');
    boolean caught = false;
    try{
        Translator.binToByte("1111111");
    }catch(Exception e){
    	    caught = true;
    }
    assertTrue("Check invalid input length", caught);
    // JUnitDoclet end method binToByte
  }
  
  public void testByteToHex() throws Exception {
    // JUnitDoclet begin method byteToHex
    assertEquals(Translator.byteToHex(new int[] {0x01, 0x80, 0xff}),
        "0180FF");
    assertEquals(Translator.byteToHex(new int[] {'A', 'B', 'C'}),
        "414243");
    // JUnitDoclet end method byteToHex
  }
  
  public void testHexToByte() throws Exception {
    // JUnitDoclet begin method hexToByte
    int[] data = Translator.hexToByte("0180FF");
    assertEquals(data[0], 0x01);
    assertEquals(data[1], 0x80);
    assertEquals(data[2], 0xff);
    data = Translator.hexToByte("414243");
    assertEquals(data[0], 'A');
    assertEquals(data[1], 'B');
    assertEquals(data[2], 'C');
    boolean caught = false;
    try{
        Translator.binToByte("AAA");
    }catch(Exception e){
            caught = true;
    }
    assertTrue("Check invalid input length", caught);
    // JUnitDoclet end method hexToByte
  }
  
  public void testByteToAscii() throws Exception {
    // JUnitDoclet begin method byteToAscii
    assertEquals(Translator.byteToAscii(new int[] {0x01, 0x80, 0xff}),
        "" + String.valueOf((char) 0x01) + String.valueOf((char) 0x80) + String.valueOf((char) 0xff));
    assertEquals(Translator.byteToAscii(new int[] {'A', 'B', 'C'}),
        "ABC");
    // JUnitDoclet end method byteToAscii
  }
  
  public void testAsciiToByte() throws Exception {
    // JUnitDoclet begin method asciiToByte
    int[] data = Translator.asciiToByte("" + new Character((char) 0x01) + new Character((char) 0x80) + new Character((char) 0xff));
    assertEquals(data[0], 0x01);
    assertEquals(data[1], 0x80);
    assertEquals(data[2], 0xff);
    data = Translator.asciiToByte("ABC");
    assertEquals(data[0], 'A');
    assertEquals(data[1], 'B');
    assertEquals(data[2], 'C');
    // JUnitDoclet end method asciiToByte
  }
  
  public void testByteToPrintableAscii() throws Exception {
    // JUnitDoclet begin method byteToPrintableAscii
    // JUnitDoclet end method byteToPrintableAscii
  }
  
  public void testNormalizeString() throws Exception {
    // JUnitDoclet begin method normalizeString
    // JUnitDoclet end method normalizeString
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(TranslatorTest.class);
    // JUnitDoclet end method testcase.main
  }
}
